//Compact Solitaire
//Version 1.1 (November 2006)
//Copyright 2006 by Donnie Russell



#include <windows.h>
#include <wingdi.h>

#include <dsound.h>

#include <stdio.h>
#include <stdlib.h>

#include "interface.h"



//...........................................................................
#define MYCLASSNAME  "CompSolClass"
#define MYTITLE      "Compact Solitaire"



#define ELAPSED_CONVERSION_CONSTANT     1000000 //1000 converts to milliseconds
#define INPUT_ELAPSED_CONVERSION_CONSTANT  1000 //1000 converts to milliseconds
#define CLICK_INTERVAL                     200  //milliseconds



HINSTANCE hInstance = 0;
HWND hWnd = 0;
HDC hDC = 0;

HBITMAP hBmp = 0;
HDC hMemDC = 0;
HBITMAP hOldBmp = 0;



int WndProcEnabled = 0;



int virtualkey = 0, typedch = 0;
int MouseX = 0, MouseY = 0, MouseB = 0;
int LeftMouseButtonClicks = 0;
unsigned long LeftMouseButtonCount = 0;



int UpdateX1 = 0, UpdateX2 = CLIENTW-1, UpdateY1 = 0, UpdateY2 = CLIENTH-1;

IMG ClientIMG = {0, 0, 0};
//...........................................................................



//****************************************************************************
HANDLE process_handle, thread_handle;



//exec command in non-active, minimized window
//return: 0 failed
int ExecCommand(char *command)
{
  SECURITY_ATTRIBUTES sa;
  STARTUPINFO si;
  PROCESS_INFORMATION pi;

  sa.nLength = sizeof(SECURITY_ATTRIBUTES);
  sa.lpSecurityDescriptor = NULL;
  sa.bInheritHandle = TRUE;

  si.cb = sizeof(STARTUPINFO);
  si.lpReserved = NULL;
  si.lpDesktop = NULL;
  si.lpTitle = NULL;
  si.dwX = 0;
  si.dwY = 0;
  si.dwXSize = 0;
  si.dwYSize = 0;
  si.dwXCountChars = 0;
  si.dwYCountChars = 0;
  si.dwFillAttribute = 0;
  si.dwFlags = STARTF_USESHOWWINDOW;
  si.wShowWindow = SW_SHOWMINNOACTIVE;
  si.cbReserved2 = 0;
  si.lpReserved2 = NULL;
  si.hStdInput = 0;
  si.hStdOutput = 0;
  si.hStdError = 0;

  if (CreateProcess(NULL, command, &sa, &sa, TRUE, NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi))
  {
    process_handle = pi.hProcess;
    thread_handle = pi.hThread;

    return 1;
  }

  return 0;
}



//return: 0 exec not finished yet
int MonitorExec(void)
{
  DWORD ExitCode;

  GetExitCodeProcess(process_handle, &ExitCode); if (ExitCode==STILL_ACTIVE) return 0;

  CloseHandle(thread_handle);
  CloseHandle(process_handle);

  return 1;
}
//****************************************************************************



//****************************************************************************
void GradientFillClientIMG(PIXEL_TYPE color1, PIXEL_TYPE color2)
{
  PIXEL_TYPE *g, *d, color;
  int w, h, dd, i;

#if PIXEL_BITS==16
  unsigned long *dl, colorl;
#endif

  static int first_time = 1;

  static PIXEL_TYPE gradient[CLIENTH];



  if (first_time)
  {
    int jj, j;

    jj = (1<<16)/CLIENTH; j = 0; for (i=0; i<CLIENTH; i++)
    {
      gradient[i] = COLOR(COLOR_R(color1)+(((COLOR_R(color2)-COLOR_R(color1))*j)>>16),
                          COLOR_G(color1)+(((COLOR_G(color2)-COLOR_G(color1))*j)>>16),
                          COLOR_B(color1)+(((COLOR_B(color2)-COLOR_B(color1))*j)>>16));
      j += jj;
    }
    first_time = 0;
  }



  w = UpdateX2-UpdateX1+1; h = UpdateY2-UpdateY1+1; if (w<=0 || h<=0) return;

  g = gradient+UpdateY1;
  d = ClientIMG.p+CLIENTW*(CLIENTH-1-UpdateY1)+UpdateX1; dd = CLIENTW+w;



  while (h--)
  {
    color = *g++;

#if PIXEL_BITS==16
    colorl = ((unsigned long)color<<16)|(unsigned long)color;
    dl = (unsigned long *)d; i = w>>1; while (i--) *dl++ = colorl;
    d = (PIXEL_TYPE *)dl; if (w&1) *d++ = color;
#endif

#if PIXEL_BITS==32
    i = w; while (i--) *d++ = color;
#endif

    d -= dd;
  }
}



void ClearIMG(IMG *img, PIXEL_TYPE color)
{
  PIXEL_TYPE *d;
  int w, h, dd, i;

#if PIXEL_BITS==16
  unsigned long *dl, colorl = ((unsigned long)color<<16)|(unsigned long)color;
#endif

  {
    int x1, x2, y1, y2;

    if (img==&ClientIMG) {x1 = UpdateX1; x2 = UpdateX2; y1 = UpdateY1; y2 = UpdateY2;}
    else {x1 = 0; x2 = img->w-1; y1 = 0; y2 = img->h-1;}

    w = x2-x1+1; h = y2-y1+1; if (w<=0 || h<=0) return;

    d = img->p+img->w*(img->h-1-y1)+x1; dd = img->w+w;
  }



  while (h--)
  {

#if PIXEL_BITS==16
    dl = (unsigned long *)d; i = w>>1; while (i--) *dl++ = colorl;
    d = (PIXEL_TYPE *)dl; if (w&1) *d++ = color;
#endif

#if PIXEL_BITS==32
    i = w; while (i--) *d++ = color;
#endif

    d -= dd;
  }
}



void PutFilledRect(IMG *img, int x1, int y1, int x2, int y2, PIXEL_TYPE color)
{
  PIXEL_TYPE *d;
  int w, h, dd, i;

#if PIXEL_BITS==16
  unsigned long *dl, colorl = ((unsigned long)color<<16)|(unsigned long)color;
#endif

  {
    int left, right, top, bottom;

    if (img==&ClientIMG) {left = UpdateX1; right = UpdateX2; top = UpdateY1; bottom = UpdateY2;}
    else {left = 0; right = img->w-1; top = 0; bottom = img->h-1;}

    if (x1<left  ) x1 = left;
    if (x2>right ) x2 = right;
    if (y1<top   ) y1 = top;
    if (y2>bottom) y2 = bottom;

    w = x2-x1+1; h = y2-y1+1; if (w<=0 || h<=0) return;

    d = img->p+img->w*(img->h-1-y1)+x1; dd = img->w+w;
  }



  while (h--)
  {

#if PIXEL_BITS==16
    dl = (unsigned long *)d; i = w>>1; while (i--) *dl++ = colorl;
    d = (PIXEL_TYPE *)dl; if (w&1) *d++ = color;
#endif

#if PIXEL_BITS==32
    i = w; while (i--) *d++ = color;
#endif

    d -= dd;
  }
}



#define SHADE_AMOUNT  ((1<<16)*2/8)



void ShadeRect(IMG *img, int x1, int y1, int x2, int y2)
{
  PIXEL_TYPE *d, color;
  int w, h, dd, i;

  {
    int left, right, top, bottom;

    if (img==&ClientIMG) {left = UpdateX1; right = UpdateX2; top = UpdateY1; bottom = UpdateY2;}
    else {left = 0; right = img->w-1; top = 0; bottom = img->h-1;}

    if (x1<left  ) x1 = left;
    if (x2>right ) x2 = right;
    if (y1<top   ) y1 = top;
    if (y2>bottom) y2 = bottom;

    w = x2-x1+1; h = y2-y1+1; if (w<=0 || h<=0) return;

    d = img->p+img->w*(img->h-1-y1)+x1; dd = img->w+w;
  }



  while (h--)
  {
    i = w; while (i--)
    {
      color = *d;

      *d++ = COLOR(COLOR_R(color)-((COLOR_R(color)*SHADE_AMOUNT)>>16),
                   COLOR_G(color)-((COLOR_G(color)*SHADE_AMOUNT)>>16),
                   COLOR_B(color)-((COLOR_B(color)*SHADE_AMOUNT)>>16));
    }

    d -= dd;
  }
}



void Blit(IMG *si, int sx, int sy, IMG *di, int dx, int dy, int w, int h)
{
  PIXEL_TYPE *s, *d;
  int ss, dd, i;

  {
    int x1, x2, y1, y2, clip;

    if (di==&ClientIMG) {x1 = UpdateX1; x2 = UpdateX2; y1 = UpdateY1; y2 = UpdateY2;}
    else {x1 = 0; x2 = di->w-1; y1 = 0; y2 = di->h-1;}

    clip = dx-x1; if (clip<0) {w += clip; sx -= clip; dx = x1;}
    clip = dx+w-(x2+1); if (clip>0) w -= clip;
    if (w<=0 || sx<0 || sx+w-(si->w)>0) return;

    clip = dy-y1; if (clip<0) {h += clip; sy -= clip; dy = y1;}
    clip = dy+h-(y2+1); if (clip>0) h -= clip;
    if (h<=0 || sy<0 || sy+h-(si->h)>0) return;

    s = si->p+si->w*(si->h-1-sy)+sx; ss = si->w+w;
    d = di->p+di->w*(di->h-1-dy)+dx; dd = di->w+w;
  }



  while (h--)
  {
    i = w; while (i--) *d++ = *s++;
    s -= ss;
    d -= dd;
  }
}



void MaskedBlit(IMG *si, int sx, int sy, IMG *di, int dx, int dy, int w, int h)
{
  PIXEL_TYPE *s, *d;
  int ss, dd, i;

  {
    int x1, x2, y1, y2, clip;

    if (di==&ClientIMG) {x1 = UpdateX1; x2 = UpdateX2; y1 = UpdateY1; y2 = UpdateY2;}
    else {x1 = 0; x2 = di->w-1; y1 = 0; y2 = di->h-1;}

    clip = dx-x1; if (clip<0) {w += clip; sx -= clip; dx = x1;}
    clip = dx+w-(x2+1); if (clip>0) w -= clip;
    if (w<=0 || sx<0 || sx+w-(si->w)>0) return;

    clip = dy-y1; if (clip<0) {h += clip; sy -= clip; dy = y1;}
    clip = dy+h-(y2+1); if (clip>0) h -= clip;
    if (h<=0 || sy<0 || sy+h-(si->h)>0) return;

    s = si->p+si->w*(si->h-1-sy)+sx; ss = si->w+w;
    d = di->p+di->w*(di->h-1-dy)+dx; dd = di->w+w;
  }



  while (h--)
  {
    i = w; while (i--) {if (*s!=MASK_COLOR) *d = *s; s++; d++;}
    s -= ss;
    d -= dd;
  }
}



//box filter is best suited for 1/2 rescaling
//for this function, di must be exactly 1/2 dimensions of si
void RescaleBox(IMG *si, IMG *di)
{
  PIXEL_TYPE *d;
  int i, j, x, y, c0, c1, c2, c3;

  for (j=0; j<di->h; j++)
  {
    d = di->p+di->w*j;
    for (i=0; i<di->w; i++)
    {
      x = i<<1; y = j<<1;

      c0 = *(si->p+si->w*(y+0)+x+0);
      c1 = *(si->p+si->w*(y+1)+x+0);
      c2 = *(si->p+si->w*(y+0)+x+1);
      c3 = *(si->p+si->w*(y+1)+x+1);

      *d++ = COLOR((COLOR_R(c0)+COLOR_R(c1)+COLOR_R(c2)+COLOR_R(c3))>>2,
                   (COLOR_G(c0)+COLOR_G(c1)+COLOR_G(c2)+COLOR_G(c3))>>2,
                   (COLOR_B(c0)+COLOR_B(c1)+COLOR_B(c2)+COLOR_B(c3))>>2);
    }
  }
}



//linear interpolation
void RescaleLinear(IMG *si, IMG *di)
{
  PIXEL_TYPE *d;
  double stepw, steph, posw, posh, d0, d1, w0, w1, w2, w3;
  int i, j, c0, c1, c2, c3;

  stepw = (double)(si->w-2)/di->w; if (stepw<=0.0) return;
  steph = (double)(si->h-2)/di->h; if (steph<=0.0) return;

  posh = 0;
  for (j=0; j<di->h; j++)
  {
    posw = 0;
    d = di->p+di->w*j;
    for (i=0; i<di->w; i++)
    {
      d0 = posw-(int)posw; d1 = posh-(int)posh;
      w0 = (1.0-d0)*(1.0-d1); w1 = (1.0-d0)*d1; w2 = d0*(1.0-d1); w3 = d0*d1;

      c0 = *(si->p+si->w*((int)posh+0)+(int)posw+0);
      c1 = *(si->p+si->w*((int)posh+1)+(int)posw+0);
      c2 = *(si->p+si->w*((int)posh+0)+(int)posw+1);
      c3 = *(si->p+si->w*((int)posh+1)+(int)posw+1);

      *d++ = COLOR((int)(w0*COLOR_R(c0)+w1*COLOR_R(c1)+w2*COLOR_R(c2)+w3*COLOR_R(c3)),
                   (int)(w0*COLOR_G(c0)+w1*COLOR_G(c1)+w2*COLOR_G(c2)+w3*COLOR_G(c3)),
                   (int)(w0*COLOR_B(c0)+w1*COLOR_B(c1)+w2*COLOR_B(c2)+w3*COLOR_B(c3)));

      posw += stepw;
    }
    posh += steph;
  }
}



void Rescale(IMG *si, IMG *di)
{
  if (si->w>>1==di->w && si->h>>1==di->h) RescaleBox(si, di); else RescaleLinear(si, di);
}
//****************************************************************************



//****************************************************************************
PIXEL_TYPE LoadIMG_RGB[256];



//only loads 4bpp and 8bpp (with palette)
int LoadIMG(IMG *img, char *filename)
{
  unsigned short bfType;          // 0 Specifies the type of file. This member must be BM.
  unsigned long  bfSize;          // 2 Specifies the size of the file, in bytes.
  unsigned short bfReserved1;     // 6 Reserved; must be set to zero.
  unsigned short bfReserved2;     // 8 Reserved; must be set to zero.
  unsigned long  bfOffBits;       //10 Specifies the byte offset from the BITMAPFILEHEADER structure to the actual bitmap data in the file.

  unsigned long  biSize;          //14 Specifies the number of bytes required by the BITMAPINFOHEADER structure.
  long           biWidth;         //18 Specifies the width of the bitmap, in pixels.
  long           biHeight;        //22 Specifies the height of the bitmap, in pixels.
  unsigned short biPlanes;        //26 Specifies the number of planes for the target device. This member must be set to 1.
  unsigned short biBitCount;      //28 Specifies the number of bits per pixel. This value must be 1, 4, 8, or 24.
  unsigned long  biCompression;   //30 Specifies the type of compression for a compressed bitmap.
  unsigned long  biSizeImage;     //34 Specifies the size, in bytes, of the image.
  long           biXPelsPerMeter; //38 Specifies the horizontal resolution, in pixels per meter, of the target device for the bitmap.
  long           biYPelsPerMeter; //42 Specifies the vertical resolution, in pixels per meter, of the target device for the bitmap.
  unsigned long  biClrUsed;       //46 Specifies the number of color indexes in the color table actually used by the bitmap.
  unsigned long  biClrImportant;  //50 Specifies the number of color indexes that are considered important for displaying the bitmap.

  FILE *f;
  int r, g, b, x, y, i = 0, j = 0;
  PIXEL_TYPE *p, *q;

  f = fopen(filename, "rb"); if (f==0) return 0;

  fseek(f,  0, SEEK_SET); fread(&bfType         , 2, 1, f);
  fseek(f,  2, SEEK_SET); fread(&bfSize         , 4, 1, f);
  fseek(f,  6, SEEK_SET); fread(&bfReserved1    , 2, 1, f);
  fseek(f,  8, SEEK_SET); fread(&bfReserved2    , 2, 1, f);
  fseek(f, 10, SEEK_SET); fread(&bfOffBits      , 4, 1, f);

  fseek(f, 14, SEEK_SET); fread(&biSize         , 4, 1, f);
  fseek(f, 18, SEEK_SET); fread(&biWidth        , 4, 1, f);
  fseek(f, 22, SEEK_SET); fread(&biHeight       , 4, 1, f);
  fseek(f, 26, SEEK_SET); fread(&biPlanes       , 2, 1, f);
  fseek(f, 28, SEEK_SET); fread(&biBitCount     , 2, 1, f);
  fseek(f, 30, SEEK_SET); fread(&biCompression  , 4, 1, f);
  fseek(f, 34, SEEK_SET); fread(&biSizeImage    , 4, 1, f);
  fseek(f, 38, SEEK_SET); fread(&biXPelsPerMeter, 4, 1, f);
  fseek(f, 42, SEEK_SET); fread(&biYPelsPerMeter, 4, 1, f);
  fseek(f, 46, SEEK_SET); fread(&biClrUsed      , 4, 1, f);
  fseek(f, 50, SEEK_SET); fread(&biClrImportant , 4, 1, f);

  if (biBitCount!=4 && biBitCount!=8) {fclose(f); return 0;}

  p = (PIXEL_TYPE *)malloc(sizeof(PIXEL_TYPE)*biWidth*biHeight); if (p==0) {fclose(f); return 0;}

  fseek(f, 14+biSize, SEEK_SET);
  for (i=0; i<256; i++)
  {
    b = fgetc(f); g = fgetc(f); r = fgetc(f); fgetc(f);
    LoadIMG_RGB[i] = (PIXEL_TYPE)(COLOR(r,g,b));
  }

  fseek(f, bfOffBits, SEEK_SET);
  for (y=0; y<biHeight; y++)
  {
    q = p+biWidth*y;

    for (x=0; x<biWidth; x++)
    {
      if (biBitCount==4) {if ((x&1)==0) {j = fgetc(f); i = j>>4;} else i = j&15;}
      else if (biBitCount==8) i = fgetc(f);

      *q++ = LoadIMG_RGB[i];
    }

    while (x&3) {fgetc(f); x++;}
  }

  fclose(f);

  img->w = biWidth;
  img->h = biHeight;
  img->p = p;

  return 1;
}



int AllocIMG(IMG *img, int w, int h)
{
  PIXEL_TYPE *p;

  p = (PIXEL_TYPE *)malloc(sizeof(PIXEL_TYPE)*w*h); if (p==0) return 0;

  img->w = w;
  img->h = h;
  img->p = p;

  return 1;
}



void FreeIMG(IMG *img)
{
  if (img->p) {free(img->p); img->p = 0;}
}
//****************************************************************************



//****************************************************************************
#define MAX_CHANNELS  8 //maximum number of sounds that can play simultaneously



#define NUM_RESOURCES  6

struct {char *r; char *f;} ResourceToFilename[NUM_RESOURCES] =
{
  { "PickupSound", "data/pickup.wav" },
  {   "DropSound", "data/drop.wav"   },
  {   "DealSound", "data/deal.wav"   },
  {   "FlipSound", "data/flip.wav"   },
  {"RecycleSound", "data/recycle.wav"},
  { "ButtonSound", "data/button.wav" }
};



IDirectSound *pDS = 0;



int DSParseWaveResource(void *pvRes, WAVEFORMATEX **ppWaveHeader, BYTE **ppbWaveData, DWORD *pcbWaveSize)
{
  DWORD dwRiff, dwType, dwLength, *pdw, *pdwEnd;

  if (ppWaveHeader) *ppWaveHeader = 0;
  if (ppbWaveData) *ppbWaveData = 0;
  if (pcbWaveSize) *pcbWaveSize = 0;
  pdw = (DWORD *)pvRes;
  dwRiff = *pdw++;
  dwLength = *pdw++;
  dwType = *pdw++;
  if (dwRiff!=mmioFOURCC('R', 'I', 'F', 'F')) return 0;
  if (dwType!=mmioFOURCC('W', 'A', 'V', 'E')) return 0;
  pdwEnd = (DWORD *)((BYTE *)pdw+dwLength-4);
  while (pdw<pdwEnd)
  {
    dwType = *pdw++;
    dwLength = *pdw++;
    switch (dwType)
    {
      case mmioFOURCC('f', 'm', 't', ' '):
        if (ppWaveHeader && !*ppWaveHeader)
        {
          if (dwLength<sizeof(WAVEFORMAT)) return 0;
          *ppWaveHeader = (WAVEFORMATEX *)pdw;
          if ((!ppbWaveData || *ppbWaveData) && (!pcbWaveSize || *pcbWaveSize)) return 1;
        }
      break;
      case mmioFOURCC('d', 'a', 't', 'a'):
        if ((ppbWaveData && !*ppbWaveData) || (pcbWaveSize && !*pcbWaveSize))
        {
          if (ppbWaveData) *ppbWaveData = (LPBYTE)pdw;
          if (pcbWaveSize) *pcbWaveSize = dwLength;
          if (!ppWaveHeader || *ppWaveHeader) return 1;
        }
      break;
    }
    pdw = (DWORD *)((BYTE *)pdw+((dwLength+1)&~1));
  }
  return 0;
}



IDirectSoundBuffer *DSLoadSoundBuffer(char *filename)
{
  IDirectSoundBuffer *pDSB;
  FILE *f;
  DWORD filesize;
  void *p;
  DSBUFFERDESC dsBD;
  BYTE *pbWaveData;
  LPVOID pMem1, pMem2;
  DWORD dwSize1, dwSize2;

  f = fopen(filename, "rb"); if (f==0) return 0;
  fseek(f, 0, SEEK_END); filesize = ftell(f);
  p = (void *)malloc(filesize); if (p==0) {fclose(f); return 0;}
  fseek(f, 0, SEEK_SET); fread(p, 1, filesize, f);
  fclose(f);

  if (DSParseWaveResource(p, &dsBD.lpwfxFormat, &pbWaveData, &dsBD.dwBufferBytes)==0) {free(p); return 0;}

  dsBD.dwSize = sizeof(DSBUFFERDESC);
  dsBD.dwFlags = DSBCAPS_STATIC|DSBCAPS_GETCURRENTPOSITION2;
  dsBD.dwReserved = 0;
  if (IDirectSound_CreateSoundBuffer(pDS, &dsBD, &pDSB, 0)!=DS_OK) {free(p); return 0;}

  if (IDirectSoundBuffer_Lock(pDSB, 0, dsBD.dwBufferBytes, &pMem1, &dwSize1, &pMem2, &dwSize2, 0)!=DS_OK) {IDirectSoundBuffer_Release(pDSB); free(p); return 0;}

  CopyMemory(pMem1, pbWaveData, dwSize1);
  if (dwSize2!=0) CopyMemory(pMem2, pbWaveData+dwSize1, dwSize2);

  IDirectSoundBuffer_Unlock(pDSB, pMem1, dwSize1, pMem2, dwSize2);

  free(p);

  return pDSB;
}



//rate: frequency in hertz 11025 22050 44100
//bits: size of each sample in bits 8 16
//channels: 1 mono 2 stereo(samples interleaved)
int InitDirectSound(int rate, int bits, int channels)
{
  HWND hWnd;
  IDirectSoundBuffer *pDSB;
  DSBUFFERDESC dsBD;
  WAVEFORMATEX wfex;

  if (pDS) return 1;

  if (DirectSoundCreate(0, &pDS, 0)!=DS_OK) {pDS = 0; return 0;}

  hWnd = GetForegroundWindow(); if (hWnd==0) hWnd = GetDesktopWindow();
  if (IDirectSound_SetCooperativeLevel(pDS, hWnd, DSSCL_PRIORITY)!=DS_OK) {IDirectSound_Release(pDS); pDS = 0; return 0;}

  dsBD.dwSize = sizeof(DSBUFFERDESC);
  dsBD.dwFlags = DSBCAPS_PRIMARYBUFFER;
  dsBD.dwBufferBytes = 0;
  dsBD.dwReserved = 0;
  dsBD.lpwfxFormat = 0;
  if (IDirectSound_CreateSoundBuffer(pDS, &dsBD, &pDSB, 0)!=DS_OK) {IDirectSound_Release(pDS); pDS = 0; return 0;}

  wfex.wFormatTag = WAVE_FORMAT_PCM;
  wfex.nSamplesPerSec = rate;
  wfex.wBitsPerSample = (WORD)bits;
  wfex.nChannels = (WORD)channels;
  wfex.nBlockAlign = wfex.wBitsPerSample*wfex.nChannels/8;
  wfex.nAvgBytesPerSec = wfex.nBlockAlign*wfex.nSamplesPerSec;
  wfex.cbSize = 0;
  IDirectSoundBuffer_SetFormat(pDSB, &wfex);

  IDirectSoundBuffer_Play(pDSB, 0, 0, DSBPLAY_LOOPING);

  return 1;
}



void ShutdownDirectSound(void)
{
  if (pDS) {IDirectSound_Release(pDS); pDS = 0;}
}



//----------------------------------------------------------------------------



IDirectSoundBuffer *pDSB_Channels[MAX_CHANNELS];



void ShutdownAudio(void)
{
  if (pDS==0) return;

  ShutdownDirectSound();
}



int InitAudio(void)
{
  int i;

  if (pDS) return 1;

  if (InitDirectSound(22050, 16, 2)==0) return 0;

  atexit(ShutdownAudio);

  for (i=0; i<MAX_CHANNELS; i++) pDSB_Channels[i] = 0;

  return 1;
}



//return: number of channels currently playing
int ServiceAudio(void)
{
  int i, count;
  DWORD status;

  if (pDS==0) return 0;

  count = 0;
  for (i=0; i<MAX_CHANNELS; i++)
  {
    if (pDSB_Channels[i]==0) continue;
    IDirectSoundBuffer_GetStatus(pDSB_Channels[i], &status);
    if ((status&DSBSTATUS_PLAYING)==0)
    {
      IDirectSoundBuffer_Release(pDSB_Channels[i]);
      pDSB_Channels[i] = 0;
      continue;
    }
    count++;
  }
  return count;
}



void PlayAudio(char *resource_name)
{
  int i;
  char *filename;

  if (pDS==0) return;

  for (i=0; i<NUM_RESOURCES; i++) if (strcmp(resource_name, ResourceToFilename[i].r)==0) break;
  if (i==NUM_RESOURCES) return;
  filename = ResourceToFilename[i].f;

  for (i=0; i<MAX_CHANNELS; i++) if (pDSB_Channels[i]==0) break;
  if (i==MAX_CHANNELS) return;

  pDSB_Channels[i] = DSLoadSoundBuffer(filename);
  if (pDSB_Channels[i]==0) return;

  IDirectSoundBuffer_Play(pDSB_Channels[i], 0, 0, 0);
}
//****************************************************************************



//**************************************************************************
//update region grows to cover all specified regions
void SetUpdateRegion(int x1, int x2, int y1, int y2)
{
  if (x1<0) x1 = 0; if (x2>CLIENTW-1) x2 = CLIENTW-1;
  if (y1<0) y1 = 0; if (y2>CLIENTH-1) y2 = CLIENTH-1;

  if (x1<UpdateX1) UpdateX1 = x1; if (x2>UpdateX2) UpdateX2 = x2;
  if (y1<UpdateY1) UpdateY1 = y1; if (y2>UpdateY2) UpdateY2 = y2;
}



void SetUpdateRegion_Empty(void)
{
  UpdateX1 = CLIENTW-1; UpdateX2 = 0;
  UpdateY1 = CLIENTH-1; UpdateY2 = 0;
}



void SetUpdateRegion_Full(void)
{
  UpdateX1 = 0; UpdateX2 = CLIENTW-1;
  UpdateY1 = 0; UpdateY2 = CLIENTH-1;
}



void UpdateClient(void)
{
  int w, h;

  w = UpdateX2-UpdateX1+1;
  h = UpdateY2-UpdateY1+1;

  if (w>0 && h>0) BitBlt(hDC, UpdateX1, UpdateY1, w, h, hMemDC, UpdateX1, UpdateY1, SRCCOPY);

  SetUpdateRegion_Empty();
}
//***************************************************************************



//***************************************************************************
//flag: 0 start 1 return elapsed time since start
int GetInputElapsed(unsigned long *count, int flag)
{
  unsigned long f, c;

  f = 1000; //ticks per second
  c = GetTickCount(); //number of ticks since Windows started
  if (flag==0) {*count = c; return 0;}
  return (c-*count)*INPUT_ELAPSED_CONVERSION_CONSTANT/f;
}



//flag: 1 pressed 0 released
void LeftMouseButton(int flag)
{
  if (flag)
  {
    MouseB |=  1;
    SetCapture(hWnd);

    if (LeftMouseButtonCount!=0)
    {
      if (GetInputElapsed(&LeftMouseButtonCount, 1)<=CLICK_INTERVAL)
      {
        LeftMouseButtonClicks++;
        if (LeftMouseButtonClicks==1) MouseB |= 2;
        else if (LeftMouseButtonClicks==2) MouseB |= 4;
        else LeftMouseButtonClicks = 0;
      }
      else LeftMouseButtonClicks = 0;
    }

    GetInputElapsed(&LeftMouseButtonCount, 0);
  }
  else
  {
    MouseB &= ~1;
    ReleaseCapture();
  }
}



//flag: 1 pressed 0 released
void RightMouseButton(int flag)
{
  if (flag)
  {
    MouseB |=  8;
    SetCapture(hWnd);
  }
  else
  {
    MouseB &= ~8;
    ReleaseCapture();
  }
}



LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (WndProcEnabled) switch (uMsg)
  {
    case WM_CLOSE: PostQuitMessage(0); return 0;

    case WM_PAINT:
      if (GetUpdateRect(hWnd, 0, 0))
      {
        RECT r;

        GetUpdateRect(hWnd, &r, 0);

        SetUpdateRegion(r.left, r.right-1, r.top, r.bottom-1);
        UpdateClient();
      }
    break; //so DefWindowProc() can validate update region



    case WM_KEYDOWN: virtualkey = wParam; return 0;
    case WM_KEYUP: return 0;
    case WM_CHAR: typedch = (TCHAR)wParam; return 0;

    case WM_MOUSEMOVE: MouseX = MAKEPOINTS(lParam).x; MouseY = MAKEPOINTS(lParam).y; return 0;
    case WM_LBUTTONDOWN:  LeftMouseButton(1); return 0;
    case WM_LBUTTONUP  :  LeftMouseButton(0); return 0;
    case WM_RBUTTONDOWN: RightMouseButton(1); return 0;
    case WM_RBUTTONUP  : RightMouseButton(0); return 0;
  }

  return DefWindowProc(hWnd, uMsg, wParam, lParam);
}



void GetInput(int *code, int *ch, int *mx, int *my, int *mb)
{
  MSG msg;

  static int old_mx = -1, old_my = -1;



  ServiceAudio();
  UpdateClient();
  Sleep(5);



  WndProcEnabled = 1;
  if (PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
  {
    if (msg.message==WM_QUIT) exit(0);
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  WndProcEnabled = 0;



  *code = 0;
  switch (virtualkey)
  {
    case VK_HOME    : *code = 71; break;
    case VK_UP      : *code = 72; break;
    case VK_PRIOR   : *code = 73; break;
    case VK_SUBTRACT: *code = 74; break;
    case VK_LEFT    : *code = 75; break;
    case VK_NUMPAD5 : *code = 76; break;
    case VK_RIGHT   : *code = 77; break;
    case VK_ADD     : *code = 78; break;
    case VK_END     : *code = 79; break;
    case VK_DOWN    : *code = 80; break;
    case VK_NEXT    : *code = 81; break;
    case VK_INSERT  : *code = 82; break;
    case VK_DELETE  : *code = 83; break;

    case VK_F1      : *code = 59; break;
    case VK_F2      : *code = 60; break;
    case VK_F3      : *code = 61; break;
    case VK_F4      : *code = 62; break;
    case VK_F5      : *code = 63; break;
    case VK_F6      : *code = 64; break;
    case VK_F7      : *code = 65; break;
    case VK_F8      : *code = 66; break;
    case VK_F9      : *code = 67; break;
    case VK_F10     : *code = 68; break;
  }
  virtualkey = 0;



  *ch = typedch; typedch = 0;



  if (old_mx==-1) {old_mx = MouseX; old_my = MouseY;}

  *mx = (old_mx+MouseX)/2; old_mx = MouseX;
  *my = (old_my+MouseY)/2; old_my = MouseY;

  *mb = MouseB; MouseB &= ~(2|4);
}



//flag: 0 start 1 return elapsed time since start
int GetElapsed(int flag)
{
  unsigned long f, c, e;

  static unsigned long start;

  f = 1000; //ticks per second
  c = GetTickCount(); //number of ticks since Windows started
  if (flag==0) {start = c; return 0;}
  e = (c-start)*ELAPSED_CONVERSION_CONSTANT/f; if (e<1) e = 1;
  return e;
}
//***************************************************************************



//****************************************************************************
#define NUM_CURSORS  2


HCURSOR CursorHandle[NUM_CURSORS] = {0, 0};



char CursorShape[(32*32)*NUM_CURSORS+1] =
//--------------------------------
"...............00..............."
"............00011000............"
"...........0110110110..........."
"...........011011011000........."
"..........00110110110110........"
".........010111111110110........"
"........0110111111111110........"
"........0111111111111110........"
"........0111111111111110........"
"........0111111111111110........"
"........0111111111111110........"
".........01111111111110........."
".........01111111111110........."
"..........0111111111110........."
"..........011111111110.........."
"...........01111111110.........."
"............011111110..........."
"............011111110..........."
"............000000000..........."
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
//--------------------------------
"...............11..............."
"............11100111............"
"...........1001001001..........."
"...........100100100111........."
"..........11001001001001........"
".........101000000001001........"
"........1001000000000001........"
"........1000000000000001........"
"........1000000000000001........"
"........1000000000000001........"
"........1000000000000001........"
".........10000000000001........."
".........10000000000001........."
"..........1000000000001........."
"..........100000000001.........."
"...........10000000001.........."
"............100000001..........."
"............100000001..........."
"............111111111..........."
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
//--------------------------------
;



//hx, hy: hotspot
HCURSOR MakeCursorFromShape(char *shape, int flipx, int flipy, int swapxy, int hx, int hy)
{
  int x, y, ch;
  unsigned char and_plane[4*32], xor_plane[4*32], *p, *q, a, b;
  HCURSOR hc;

  p = and_plane; q = xor_plane; a = b = 0;
  for (y=0; y<32; y++) for (x=0; x<32; x++)
  {
    ch = shape[(swapxy?1:32)*(flipy?31-y:y)+(swapxy?32:1)*(flipx?31-x:x)];
    switch (ch)
    {
      case '0': a = (a<<1)|0; b = (b<<1)|0; break;
      case '1': a = (a<<1)|0; b = (b<<1)|1; break;
      case '.': a = (a<<1)|1; b = (b<<1)|0; break;
      case 'r': a = (a<<1)|1; b = (b<<1)|1; break;
    }
    if ((x&7)==7) {*p++ = a; *q++ = b; a = b = 0;}
  }

  hc = CreateCursor(hInstance, hx, hy, 32, 32, (void *)and_plane, (void *)xor_plane);
  return hc;
}



void ChangeCursor(int i)
{
  HCURSOR hc;

  if (i<0 || i>=NUM_CURSORS) hc = LoadCursor(0, IDC_ARROW);
  else hc = CursorHandle[i];

  SetCursor(hc);
}
//****************************************************************************



//***************************************************************************
void ShutdownInterface(void)
{
  int i;



  SetCursor(LoadCursor(0, IDC_ARROW));

  for (i=0; i<NUM_CURSORS; i++) if (CursorHandle[i]) {DestroyCursor(CursorHandle[i]); CursorHandle[i] = 0;}



  if (hWnd)
  {
    if (hDC)
    {
      if (hBmp)
      {
        SelectObject(hMemDC, hOldBmp); hOldBmp = 0;
        DeleteDC(hMemDC); hMemDC = 0;

        ClientIMG.p = 0;

        DeleteObject(hBmp); hBmp = 0;
      }

      ReleaseDC(hWnd, hDC); hDC = 0;
    }

    DestroyWindow(hWnd); hWnd = 0;
  }



  if (hInstance) {UnregisterClass(MYCLASSNAME, hInstance); hInstance = 0;}
}



void InitInterface(void)
{
  WNDCLASS wc;
  DWORD dwStyle = WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX;
  DWORD dwExStyle = WS_EX_CLIENTEDGE;
  BITMAPINFO *bi;
  void *p;
  RECT r;
  int ax, ay, bx, by;
  int i;



  atexit(ShutdownInterface);



  hInstance = GetModuleHandle(0);

  wc.style = CS_HREDRAW|CS_VREDRAW|CS_OWNDC;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(hInstance, "MyIcon"); //LoadIcon(0, IDI_APPLICATION)
  wc.hCursor = 0;
  wc.hbrBackground = 0;
  wc.lpszMenuName = 0;
  wc.lpszClassName = MYCLASSNAME;

  if (!RegisterClass(&wc)) {hInstance = 0; exit(1);}



  hWnd = CreateWindowEx(dwExStyle, MYCLASSNAME, MYTITLE, dwStyle, 0, 0, 0, 0, 0, 0, hInstance, 0);
  if (!hWnd) exit(1);

  hDC = GetDC(hWnd);
  if (!hDC) exit(1);



  bi = (BITMAPINFO *)malloc(sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*1024);
  if (bi==0) exit(1);

  bi->bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
  bi->bmiHeader.biWidth         = CLIENTW;
  bi->bmiHeader.biHeight        = CLIENTH;
  bi->bmiHeader.biPlanes        = 1;
  bi->bmiHeader.biBitCount      = PIXEL_BITS;
  bi->bmiHeader.biCompression   = BI_RGB;
  bi->bmiHeader.biSizeImage     = 0;
  bi->bmiHeader.biXPelsPerMeter = 0;
  bi->bmiHeader.biYPelsPerMeter = 0;
  bi->bmiHeader.biClrUsed       = 0;
  bi->bmiHeader.biClrImportant  = 0;

  hBmp = CreateDIBSection(hDC, bi, DIB_RGB_COLORS, &p, 0, 0); free(bi);
  if (!hBmp) exit(1);

  ClientIMG.w = CLIENTW;
  ClientIMG.h = CLIENTH;
  ClientIMG.p = (PIXEL_TYPE *)p;

  hMemDC = CreateCompatibleDC(hDC);
  hOldBmp = SelectObject(hMemDC, hBmp);



  r.left = 0; r.right = CLIENTW; r.top = 0; r.bottom = CLIENTH;
  AdjustWindowRectEx(&r, dwStyle, 0, dwExStyle); ax = r.right-r.left; ay = r.bottom-r.top;
  SystemParametersInfo(SPI_GETWORKAREA, 0, &r, 0); bx = r.right-r.left; by = r.bottom-r.top;
  MoveWindow(hWnd, (bx-ax)/2, (by-ay)/2, ax, ay, 1);
  ShowWindow(hWnd, SW_SHOW);



  for (i=0; i<NUM_CURSORS; i++) CursorHandle[i] = MakeCursorFromShape(CursorShape+(32*32)*i, 0, 0, 0, 15, 0);
  ChangeCursor(-1);



  InitAudio(); //if audio fails to init, it's safe to continue anyway
}
//***************************************************************************
