//Compact Solitaire
//Version 1.1 (November 2006)
//Copyright 2006 by Donnie Russell



#define PIXEL_BITS  32 //16 or 32



#define CLIENTW  800
#define CLIENTH  600



//............................................................................
#if PIXEL_BITS==16
  typedef unsigned short  PIXEL_TYPE;
  #define COLOR(r,g,b)  ((PIXEL_TYPE)( ((b)>>3) | (((g)>>3)<<5) | (((r)>>3)<<10) ))
  #define COLOR_R(c)    ((int)( (((c)>>10)&31)<<3 ))
  #define COLOR_G(c)    ((int)( (((c)>> 5)&31)<<3 ))
  #define COLOR_B(c)    ((int)( ( (c)     &31)<<3 ))
#endif

#if PIXEL_BITS==32
  typedef unsigned long  PIXEL_TYPE;
  #define COLOR(r,g,b)  ((PIXEL_TYPE)( (b) | ((g)<<8) | ((r)<<16) ))
  #define COLOR_R(c)    ((int)( ((c)>>16)&255 ))
  #define COLOR_G(c)    ((int)( ((c)>> 8)&255 ))
  #define COLOR_B(c)    ((int)(  (c)     &255 ))
#endif



#define MASK_COLOR  COLOR(0, 0, 0)



#define BLACK     COLOR(  0,   0,   0)
#define BLUE      COLOR(  0,   0, 128)
#define GREEN     COLOR(  0, 128,   0)
#define CYAN      COLOR(  0, 128, 128)
#define RED       COLOR(128,   0,   0)
#define MAGENTA   COLOR(128,   0, 128)
#define BROWN     COLOR(128,  64,   0)
#define GREY      COLOR(192, 192, 192)
#define DGREY     COLOR(128, 128, 128)
#define LBLUE     COLOR(  0,   0, 255)
#define LGREEN    COLOR(  0, 255,   0)
#define LCYAN     COLOR(  0, 255, 255)
#define LRED      COLOR(255,   0,   0)
#define LMAGENTA  COLOR(255,   0, 255)
#define YELLOW    COLOR(255, 255,   0)
#define WHITE     COLOR(255, 255, 255)



typedef struct {int w, h; PIXEL_TYPE *p;} IMG;

typedef struct {short first_ch, last_ch, max_w, max_h, w[256], h[256]; unsigned char *p;} FNT;
//............................................................................



//////////////////////////////////////////////////////////////////////////////
int ExecCommand(char *command);
int MonitorExec(void);

void GradientFillClientIMG(PIXEL_TYPE color1, PIXEL_TYPE color2);
void ClearIMG(IMG *img, PIXEL_TYPE color);
void PutFilledRect(IMG *img, int x1, int y1, int x2, int y2, PIXEL_TYPE color);
void ShadeRect(IMG *img, int x1, int y1, int x2, int y2);
void Blit(IMG *si, int sx, int sy, IMG *di, int dx, int dy, int w, int h);
void MaskedBlit(IMG *si, int sx, int sy, IMG *di, int dx, int dy, int w, int h);
void Rescale(IMG *si, IMG *di);

int LoadIMG(IMG *img, char *filename);
int AllocIMG(IMG *img, int w, int h);
void FreeIMG(IMG *img);

void PlayAudio(char *resource_name);

void SetUpdateRegion(int x1, int x2, int y1, int y2);
void SetUpdateRegion_Empty(void);
void SetUpdateRegion_Full(void);

void GetInput(int *code, int *ch, int *mx, int *my, int *mb);
int GetElapsed(int flag);

void ChangeCursor(int i);

void InitInterface(void);
//////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////
void GetCharSizeFNT(FNT *fnt, int ch, int *w, int *h);
int DrawCharFNT(FNT *fnt, int ch, IMG *img, int dx, int dy, PIXEL_TYPE color);
int DrawCharRevFlipFNT(FNT *fnt, int ch, IMG *img, int dx, int dy, PIXEL_TYPE color);

void GetStringSizeFNT(FNT *fnt, char *string, int *w, int *h);
void DrawStringFNT(FNT *fnt, char *string, IMG *img, int x, int y, PIXEL_TYPE color);
void DrawStringRevFlipFNT(FNT *fnt, char *string, IMG *img, int x, int y, PIXEL_TYPE color);

void LoadFonts(void);
//////////////////////////////////////////////////////////////////////////////
